function cdp00100_parametros_controle_producaoController (templateManager, restEngine, General, ScreenService, cdp00100_parametros_controle_producaoService){
    
    var self = this;
    var VRPRODAGUA;
    var IDLIBLOTEEST;
    
    this.setFilter = function(widget){
        var filial = widget.currentRow.CDFILIAL;
        widget.widgets.forEach(function(widget){
            widget.dataSourceFilter[0].value = filial;
            if(filial)
                widget.getAction('editar').readOnly = false;
            else
                widget.getAction('editar').readOnly = true;
        });
        if (templateManager.container.getActiveWidget().name === "form_observacao")
            self.selectObspadordpro();
        else
            templateManager.container.getActiveWidget().reload();
    };
    
    this.moveToFirst = function(widget){
        if(widget.dataSource.data[0] === undefined){
            widget.currentRow = {};
            widget.currentRow.__is_new = true;
        }
        else {
            widget.moveToFirst();
        }
    };
    
    this.reload = function(widget){
        widget.reload();
    };
    
    this.chageIsVisibleDsunidmedida = function(){
        if (templateManager.container.getActiveWidget().getField("IDUNIDADEVRINT").value() === "S"){
            templateManager.container.getActiveWidget().getField("DSUNIDMEDIDA").isVisible = true;
            templateManager.container.getActiveWidget().getField("IDUNIDADEVRINT").class = 6;
        }
        else{
            templateManager.container.getActiveWidget().getField("DSUNIDMEDIDA").isVisible = false;
            templateManager.container.getActiveWidget().getField("IDUNIDADEVRINT").class = 12;
        }
    };
    
    this.chageIsVisibleIdlibloteest = function(){
        var data;
        if (templateManager.container.getActiveWidget().getField("IDUTSEGLIBLOTE").value() === "S"){
            data = [
                {
                    "label": "Conclusão de Análise",
                    "value": "1"
                },
                {
                    "label": "Lote de Produção",
                    "value": "2"
                }
            ];
            if(IDLIBLOTEEST === "1"){
                templateManager.container.getActiveWidget().currentRow.IDLIBLOTEEST = "1";
            }
            if(IDLIBLOTEEST === "2"){
                templateManager.container.getActiveWidget().currentRow.IDLIBLOTEEST = "2";
            }
            if(IDLIBLOTEEST === "3"){
                templateManager.container.getActiveWidget().currentRow.IDLIBLOTEEST = "1";
            }
        }
        else{
            data = [
                {
                    "label": "Não Utiliza",
                    "value": "3"
                }
            ];
            templateManager.container.getActiveWidget().currentRow.IDLIBLOTEEST = "3";
        }
        templateManager.container.getActiveWidget().redraw();
        templateManager.container.getActiveWidget().getField("IDLIBLOTEEST").dataSource.data = data;
    };
    
    this.selectObspadordpro = function(){
        templateManager.container.getWidget('form_observacao').currentRow.CDFILIAL = templateManager.container.getWidget("tabbed_filial").getField("CDFILIAL").value();
        if (templateManager.container.getWidget('form_observacao').currentRow.CDPARAMAN === undefined)
            templateManager.container.getWidget('form_observacao').getField('CDPARAMAN').setValue(templateManager.container.getWidget('form_observacao').getField('CDPARAMAN').defaultValue);
        
        var filter = [
                {
                    "name": "P_CDFILIAL",
                    "operator": "=",
                    "value": templateManager.container.getWidget('form_observacao').currentRow.CDFILIAL
                },
                {
                    "name": "P_CDPARAM",
                    "operator": "=",
                    "value": templateManager.container.getWidget('form_observacao').currentRow.CDPARAMAN
                }
            ];
            
        cdp00100_parametros_controle_producaoService.selectObspadordpro(filter).then(function (response){
            if(response.dataset.Obspadordpro_controleProducao_select_txt[0]){
                templateManager.container.getWidget('form_observacao').currentRow = response.dataset.Obspadordpro_controleProducao_select_txt[0];
                if (templateManager.container.getWidget('form_observacao').currentRow.TXOBSORDPRO){
                    var TXOBSORDPRO = response.dataset.Obspadordpro_controleProducao_select_txt[0].TXOBSORDPRO;
                    if ((TXOBSORDPRO.substr(TXOBSORDPRO.length - 9).split("}")[0]) === "\\par " ){
                        TXOBSORDPRO = response.dataset.Obspadordpro_controleProducao_select_txt[0].TXOBSORDPRO.split("}")[2];
                        TXOBSORDPRO = TXOBSORDPRO.substr(TXOBSORDPRO.indexOf(" "));
                        TXOBSORDPRO = TXOBSORDPRO.substr(0,TXOBSORDPRO.indexOf('\\par '));
                    }
                    templateManager.container.getWidget('form_observacao').currentRow.TXOBSORDPRO = TXOBSORDPRO;
                }
            }
            else{
                templateManager.container.getWidget('form_observacao').currentRow= {};
            }
        });
    };
    
    this.permissaoNewRow = function (widget){
        widget.getField('DSGRUPOPER').readOnly = false;
        widget.getField('IDAUTGRUPOP').readOnly = false;
        General.widgetNewRow(widget);
    };
    
    this.savePermissao = function(widget){
        General.saveCrud(widget).then(function(){
            widget.getField('DSGRUPOPER').readOnly = true;
            widget.getField('IDAUTGRUPOP').readOnly = true;
        });
    };
    
    this.cancelPermissao = function(args){
        General.backOrCancel(args).then(function(){
            args.owner.widget.getField('DSGRUPOPER').readOnly = true;
            args.owner.widget.getField('IDAUTGRUPOP').readOnly = true;
        });
    };
    
    this.editTabbedFilial = function(widget){
        var isNew = widget.currentRow.__is_new;
        if (widget.currentRow.__is_new === undefined){
            isNew = true;
        }
        widget.getParent().getField("NMFILIAL").readOnly = true;
        General.widgetEdit(widget);
        var widgetsToDeactivate = widget.parent.parent.widgets;

		General.changeWidgetAcessibility(
			widgetsToDeactivate.filter(function (subwidget) {
				return subwidget.name != widget.parent.name;
			}).concat(widget.parent.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
		false);
		
		var widgetsToActivate = widget.parent.parent.widgets;
		
		General.changeWidgetAcessibility(
			widgetsToActivate.filter(function (subwidget) {
				return subwidget.name === widget.parent.name;
			}).concat(widget.parent.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
		true);
		widget.currentRow.__is_new = isNew;

    };
    
    this.saveTabbedFilial = function(widget){
        if (!widget.currentRow.CDFILIAL){
            widget.currentRow.CDFILIAL = widget.getParent().getField('CDFILIAL').value();
        }
        if(widget.name === "form_observacao"){
            if (!widget.currentRow.CDPARAMAN){
                widget.currentRow.CDPARAMAN = General.getFieldValue('CDPARAMAN','form_observacao');
            }
            cdp00100_parametros_controle_producaoService.salvarObspadordpro(widget.currentRow).then(function(){
                if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
                    var widgetsToActivate = widget.parent.parent.widgets;
        		
                	General.changeWidgetAcessibility(
                		widgetsToActivate.filter(function (subwidget) {
                			return subwidget.name != widget.parent.name;
                		}).concat(widget.parent.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
                	true);
                		
                	widgetsToActivate = widget.parent.widgets;
            		
                	General.changeWidgetAcessibility(
                		widgetsToActivate.filter(function (subwidget) {
                			return subwidget.name != widget.name;
                		}).concat(widget.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
                	true);
        			widget.list();
        			
                    widget.getParent().getField("NMFILIAL").readOnly = false;
                }
            }, function (error){
                if (error.data.error.indexOf('FKMAN00097PARAMAN') > 0){
                    ScreenService.errorNotification('Não há parâmetros cadastrados. Cadastre outra aba, antes de adicionar a descrição');
                } else if(error.data.errorCode === 0) {
                    ScreenService.showMessage(error.data.error);
                }else {
                    ScreenService.errorNotification('Ocorreu um Erro durante o salvamento.');
                }
            });
        }
        else{
            General.widgetSave(widget).then(function(){
    			var widgetsToActivate = widget.parent.parent.widgets;
    		
            	General.changeWidgetAcessibility(
            		widgetsToActivate.filter(function (subwidget) {
            			return subwidget.name != widget.parent.name;
            		}).concat(widget.parent.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
            	true);
            		
            	widgetsToActivate = widget.parent.widgets;
        		
            	General.changeWidgetAcessibility(
            		widgetsToActivate.filter(function (subwidget) {
            			return subwidget.name != widget.name;
            		}).concat(widget.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
            	true);
    			widget.list();
    			
                widget.getParent().getField("NMFILIAL").readOnly = false;
            });
        }
    };
    
    this.cancelTabbedFilial = function(args){
        General.backOrCancel(args).then(function (){
            var widget = args.owner.widget;
            if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
            	var widgetsToActivate = widget.parent.parent.widgets;
		
        		General.changeWidgetAcessibility(
        			widgetsToActivate.filter(function (subwidget) {
        				return subwidget.name != widget.parent.name;
        			}).concat(widget.parent.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
        		true);
        		
        		widgetsToActivate = widget.parent.widgets;
    		
        		General.changeWidgetAcessibility(
        			widgetsToActivate.filter(function (subwidget) {
        				return subwidget.name != widget.name;
        			}).concat(widget.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
        		true);
			    widget.list();
            } else
				General.changeWidgetAcessibility(widget.widgets, true);
			
        widget.getParent().getField("NMFILIAL").readOnly = false;
        });
    };
    
    this.editTabbedMatPrima = function(widget){
        self.editTabbedFilial(widget);
        var DSUNIDMEDIDA;
        
        if (widget.currentRow.DSUNIDMEDIDA)
            DSUNIDMEDIDA = widget.currentRow.DSUNIDMEDIDA.split("_");
        
        widget.currentRow.DSUNIDMEDIDA = DSUNIDMEDIDA;
    };
    
    this.saveTabbedMatPrima = function(widget){
        var DSUNIDMEDIDA = ""; 
        if (widget.currentRow.DSUNIDMEDIDA){
            widget.currentRow.DSUNIDMEDIDA.forEach(function(data){
                if (data != ""){
                    DSUNIDMEDIDA = DSUNIDMEDIDA.concat("_");
                    DSUNIDMEDIDA = DSUNIDMEDIDA.concat(data);
                }
            });
        }
        if (VRPRODAGUA != widget.currentRow.VRPRODAGUA){
            widget.currentRow.VRULTPRODAGUA = VRPRODAGUA;
        }
        widget.currentRow.VRPRODAGUA = parseFloat(widget.currentRow.VRPRODAGUA);
        widget.currentRow.DSUNIDMEDIDA = DSUNIDMEDIDA;
        self.saveTabbedFilial(widget);
    };
    
    this.setVrprodagua = function(widget){
        VRPRODAGUA = widget.getField('VRPRODAGUA').value();
    };
    
    this.setIdlibloteest = function(widget){
        IDLIBLOTEEST = widget.getField('IDLIBLOTEEST').value();
    };
    
    this.startFiltering = function(widget){
        widget.getField('NMFILIAL').reload().then(function (){
            widget.getField('NMFILIAL').dataSource.data.forEach(function (data){
                if (data.CDFILIAL === getLocalVar('CDFILIAL')){
                    widget.getField('NMFILIAL').setValue(data.NMFILIAL);
                    widget.getField('CDFILIAL').setValue(getLocalVar('CDFILIAL'));
                }
            });
            self.setFilter(widget);
        });
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('cdp00100_parametros_controle_producaoController', cdp00100_parametros_controle_producaoController);
});