function cdp01000_lote_de_producao_Controller(General, templateManager, ScreenService, cdp01000_lote_de_producao_Service) {
    
    var cdProdutoInicial = {};
    var cdProdutoFinal = {};
    var nrLoteInicial = {};
    var nrLoteFinal = {};
    
    this.verificaActions = function(widget){
        //Sitação Pendente
        if(widget.currentRow.IDSTPRODLOTE === "1" ){
            if(widget.currentRow.NMOPERLIB === ""){
                widget.actions[2].isVisible = false;
            }
            widget.actions[1].isVisible = false;
            widget.reload();
        }
        
        //Sitação Em Produção
        else if(widget.currentRow.IDSTPRODLOTE === "2" ){
            widget.actions[2].isVisible = false;
            templateManager.container.getWidget('RastreamentoLoteEmProducao').isVisible = true;
            templateManager.container.getWidget('RastreamentoLoteEmProducao').reload();
            templateManager.container.getWidget('RastreamentoLoteProduzido').isVisible = false;
            templateManager.container.getWidget('RastreamentoLoteProduzido').reload();
            widget.reload();
        }
        
        //Sitação Em Analise
        else if(widget.currentRow.IDSTPRODLOTE === "3" ){
            widget.actions[2].isVisible = false;
            widget.reload();
        }
        
        //Sitação Cancelado
        else if(widget.currentRow.IDSTPRODLOTE === "4" ){
            if(widget.currentRow.NMOPERLIB === ""){
                widget.actions[2].isVisible = false;
            }
            widget.actions[1].isVisible = false;
            widget.reload();
        }
        
        //Sitação Produzido
        else if(widget.currentRow.IDSTPRODLOTE === "5" ){
            widget.actions[2].isVisible = false;
            templateManager.container.getWidget('RastreamentoLoteProduzido').isVisible = true;
            templateManager.container.getWidget('RastreamentoLoteProduzido').reload();
            templateManager.container.getWidget('RastreamentoLoteEmProducao').isVisible = false;
            templateManager.container.getWidget('RastreamentoLoteEmProducao').reload();
            widget.reload();
        }
        
        //Sitação null
        else if(widget.currentRow.IDSTPRODLOTE === "" ){
            widget.actions[2].isVisible = false;
            widget.reload();
        }
    };
    
    this.filtroFix = function(widget){
        
        var filtro = templateManager.container.getWidget('lote_de_producao').dataSourceFilter;
        
        var indexToRemoveValiLote = filtro.findIndex(function(elemento){
            return elemento.name === "DTVALILOTE";
        });
        filtro.splice(indexToRemoveValiLote,1);
    
        var indexToRemoveLibeLote = filtro.findIndex(function(elemento){
            return elemento.name == "DTPRELIBLOTE";
        });
        filtro.splice(indexToRemoveLibeLote,1);

    };
    
    this.filtroDataValidade = function(widget){
         
        var dtInicial = templateManager.container.getWidget('lote_de_producao').dataSourceFilter.filter(function(data){
             return data.name == "P_DTINVAL";
        });
         
        var dtFinal = templateManager.container.getWidget('lote_de_producao').dataSourceFilter.filter(function(data){
             return data.name == "P_DTFIVAL";
        });
         
        var dtTotal = templateManager.container.getWidget('lote_de_producao').dataSourceFilter.filter(function(data){
             return data.name == "P_TDTVAL";
        });
             
        if(widget.owner.field.intervalWidget){
            
            dtInicial[0].value = widget.owner.field.intervalWidget.intervalData.start; 
            dtFinal[0].value = widget.owner.field.intervalWidget.intervalData.end;
            dtTotal[0].value ="";
            ScreenService.closePopup();
             
        } else{
             
             dtInicial[0].value = ""; 
             dtFinal[0].value = "";
             dtTotal[0].value ="T";
             templateManager.container.getWidget('lote_de_producao').reload();
        }
         
    };
    
    this.filtroDataPrevisao = function(widget){
         
        var dtInicial = templateManager.container.getWidget('lote_de_producao').dataSourceFilter.filter(function(data){
             return data.name == "P_DTINCON";
        });
         
        var dtFinal = templateManager.container.getWidget('lote_de_producao').dataSourceFilter.filter(function(data){
             return data.name == "P_DTFICON";
        });
         
        var dtTotal = templateManager.container.getWidget('lote_de_producao').dataSourceFilter.filter(function(data){
             return data.name == "P_TDTPRE";
        });
             
        if(widget.owner.field.intervalWidget){
            
            dtInicial[0].value = widget.owner.field.intervalWidget.intervalData.start; 
            dtFinal[0].value = widget.owner.field.intervalWidget.intervalData.end;
            dtTotal[0].value ="";
            ScreenService.closePopup();
             
        } else{
             
             dtInicial[0].value = ""; 
             dtFinal[0].value = "";
             dtTotal[0].value ="T";
             templateManager.container.getWidget('lote_de_producao').reload();
        }
         
    };
    
    this.prodIni = function(widget){
        
        cdProdutoInicial = widget.row.P_CDARVPRODDE;
        
        if((cdProdutoInicial) && (cdProdutoFinal)){

            if(cdProdutoInicial > cdProdutoFinal){
                ScreenService.showMessage("O codigo do produto inicial não pode ser maior que do final");
                widget.row.CDPRODUTOINI = "";
                widget.row.NMPRODUTOINI = "";
                widget.row.CDPRODUTOFIN = "";
                widget.row.NMPRODUTOFIN = "";
                return 0;
            }
        }
        
    };

    this.prodFin = function(widget){
    
        cdProdutoFinal = widget.row.P_CDARVPRODATE;
        
        if((cdProdutoInicial) && (cdProdutoFinal)){

            if(cdProdutoInicial > cdProdutoFinal){
                ScreenService.showMessage("O codigo do produto inicial não pode ser maior que do final");
                widget.row.P_CDARVPRODATE = "";
                widget.row.NMPRODUTOFIN = "";
                return 0;
            }
        } else if (cdProdutoInicial.length){
                widget.row.P_CDARVPRODATE = "";
                widget.row.NMPRODUTOFIN = "";
        }
    };

    this.loteIni = function(widget){
        
        nrLoteInicial = widget.row.P_LOTEINI;
        
        if((nrLoteInicial) && (nrLoteFinal)){

            if(nrLoteInicial > nrLoteFinal){
                ScreenService.showMessage("O codigo do lote inicial não pode ser maior que do final");
                widget.row.P_LOTEINI = "";
                widget.row.P_LOTEFIM = "";
                return 0;
            }
        }
        
    };
    
    this.loteFim = function(widget){
        
        nrLoteFinal = widget.row.P_LOTEFIM;
        
        if((nrLoteInicial) && (nrLoteFinal)){

            if(nrLoteInicial > nrLoteFinal){
                ScreenService.showMessage("O codigo do lote inicial não pode ser maior que do final");
                widget.row.P_LOTEFIM = "";
                return 0;
            }
        }
        
    };
    
    this.filtroRastreamento = function(widget){
         
        var cdFilialLote; 
        var cdFilialPrioridade;
        var nrLote;
         
        if(widget.currentRow.IDSTPRODLOTE === "2" ){
            
            cdFilialLote = templateManager.container.getWidget('RastreamentoLoteEmProducao').dataSourceFilter.filter(function(data){
                 return data.name == "P_CDFILIAL";
            });
             
            cdFilialPrioridade = templateManager.container.getWidget('PrioridadeWidgetEmProducao').dataSourceFilter.filter(function(data){
                 return data.name == "P_CDFILIAL";
            });
             
            nrLote = templateManager.container.getWidget('RastreamentoLoteEmProducao').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRLOTEESTQ";
            });
             
            cdFilialLote[0].value = widget.currentRow.CDFILIAL; 
            cdFilialPrioridade[0].value = widget.currentRow.CDFILIAL; 
            nrLote[0].value = widget.currentRow.NRLOTEESTQ;
            
            templateManager.container.getWidget('RastreamentoLoteEmProducao').reload();
        
        } else if(widget.currentRow.IDSTPRODLOTE === "5" ){
            
            cdFilialLote = templateManager.container.getWidget('RastreamentoLoteProduzido').dataSourceFilter.filter(function(data){
                 return data.name == "P_CDFILIAL";
            });
             
            cdFilialPrioridade = templateManager.container.getWidget('PrioridadeWidgetProduzido').dataSourceFilter.filter(function(data){
                 return data.name == "P_CDFILIAL";
            });
            
            var cdFilialAnalise = templateManager.container.getWidget('ANALINSPEC').dataSourceFilter.filter(function(data){
                 return data.name == "P_CDFILIAL";
            });
            
            var cdFilialAnaliseAtiv = templateManager.container.getWidget('ANALINSPEC_ATIV').dataSourceFilter.filter(function(data){
                 return data.name == "P_CDFILIAL";
            });
            
            var cdFilialInfoMatPri = templateManager.container.getWidget('InfoMatPrimaInsu').dataSourceFilter.filter(function(data){
                 return data.name == "P_CDFILIAL";
            });
            
            var cdFilialInfoMatPriFilha = templateManager.container.getWidget('InfoMatPrimaInsuFilha').dataSourceFilter.filter(function(data){
                 return data.name == "P_CDFILIAL";
            });
            
            nrLote = templateManager.container.getWidget('RastreamentoLoteProduzido').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRLOTEESTQ";
            });
            
            var nrLoteInfoMatPri = templateManager.container.getWidget('InfoMatPrimaInsu').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRLOTEESTQ";
            });
            
            var nrSubLote = templateManager.container.getWidget('InfoMatPrimaInsu').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRSUBLOTE";
            });
            
            var cdProdInfo = templateManager.container.getWidget('InfoMatPrimaInsu').dataSourceFilter.filter(function(data){
                 return data.name == "P_CDPRODUTO";
            });
             
            cdFilialLote[0].value = widget.currentRow.CDFILIAL; 
            cdFilialPrioridade[0].value = widget.currentRow.CDFILIAL; 
            cdFilialAnalise[0].value = widget.currentRow.CDFILIAL;
            cdFilialAnaliseAtiv[0].value = widget.currentRow.CDFILIAL;
            cdFilialInfoMatPri[0].value = widget.currentRow.CDFILIAL;
            cdFilialInfoMatPriFilha[0].value = widget.currentRow.CDFILIAL;
            nrLote[0].value = widget.currentRow.NRLOTEESTQ;
            nrLoteInfoMatPri[0].value = widget.currentRow.NRLOTEESTQ;
            nrSubLote[0].value = widget.currentRow.NRSUBLOTE;
            cdProdInfo[0].value = widget.currentRow.CDPRODUTO;
            
            templateManager.container.getWidget('RastreamentoLoteProduzido').reload();
        }

    };
    
    this.filtroRastreamentoPrioridade = function(widget){
        
        if(widget.parent.currentRow.IDSTPRODLOTE === "2" ){
            
            var nrOrdemProducao = templateManager.container.getWidget('PrioridadeWidgetEmProducao').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRORDPROD";
            });
            
            var nrSubOrdemProduto = templateManager.container.getWidget('PrioridadeWidgetEmProducao').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRSUBORDPROD";
            });
            
            
            nrOrdemProducao[0].value = widget.currentRow.NRORDPROD;
            nrSubOrdemProduto[0].value = widget.currentRow.NRSUBORDPROD;
            
            templateManager.container.getWidget('PrioridadeWidgetEmProducao').reload();

        } else if(widget.parent.currentRow.IDSTPRODLOTE === "5" ){
            
            var nrOrdemProducaoProduzido = templateManager.container.getWidget('PrioridadeWidgetProduzido').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRORDPROD";
            });
            
            var nrSubOrdemProdutoProduzido = templateManager.container.getWidget('PrioridadeWidgetProduzido').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRSUBORDPROD";
            });
            
            var nrOrdemProducaoEquip = templateManager.container.getWidget('InsumosEquip').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRORDPROD";
            });
            
            var nrSubOrdemProdutoEquip = templateManager.container.getWidget('InsumosEquip').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRSUBORDPROD";
            });
            
            var nrOrdemProducaoRecur = templateManager.container.getWidget('InsumosRecurso').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRORDPROD";
            });
            
            var nrSubOrdemProdutoRecur = templateManager.container.getWidget('InsumosRecurso').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRSUBORDPROD";
            });
            
            var nrOrdemProducaoAnalise = templateManager.container.getWidget('ANALINSPEC').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRORDPROD";
            });
            
            var nrSubOrdemProdutoAnalise = templateManager.container.getWidget('ANALINSPEC').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRSUBORDPROD";
            });
            
            var nrLoteProducaoOriginado = templateManager.container.getWidget('PRODORIGIN').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRLOTEESTQ";
            });
            
            var cdProdutoOriginado = templateManager.container.getWidget('PRODORIGIN').dataSourceFilter.filter(function(data){
                 return data.name == "P_CDPRODUTO";
            });
            
            nrOrdemProducaoProduzido[0].value = widget.currentRow.NRORDPROD;
            nrSubOrdemProdutoProduzido[0].value = widget.currentRow.NRSUBORDPROD;
            nrOrdemProducaoEquip[0].value = widget.currentRow.NRORDPROD;
            nrSubOrdemProdutoEquip[0].value = widget.currentRow.NRSUBORDPROD;
            nrOrdemProducaoRecur[0].value = widget.currentRow.NRORDPROD;
            nrSubOrdemProdutoRecur[0].value = widget.currentRow.NRSUBORDPROD;
            nrOrdemProducaoAnalise[0].value = widget.currentRow.NRORDPROD;
            nrSubOrdemProdutoAnalise[0].value = widget.currentRow.NRSUBORDPROD;
            nrLoteProducaoOriginado[0].value = widget.currentRow.NRLOTEESTQ;
            cdProdutoOriginado[0].value = widget.currentRow.CDPRODUTO;
            
            templateManager.container.getWidget('PrioridadeWidgetProduzido').reload();
            templateManager.container.getWidget('InsumosEquip').reload();
            templateManager.container.getWidget('InsumosRecurso').reload();
            templateManager.container.getWidget('ANALINSPEC').reload();
            templateManager.container.getWidget('PRODORIGIN').reload();

        }
        
    };
    
    this.filtroRastreamentoAnalise = function(widget){
        
        var nrAuditoria = templateManager.container.getWidget('ANALINSPEC_ATIV').dataSourceFilter.filter(function(data){
             return data.name == "P_NRAUDITORIA";
        });
        
        var nrInspecAudi = templateManager.container.getWidget('ANALINSPEC_ATIV').dataSourceFilter.filter(function(data){
             return data.name == "P_NRINSPECAUDI";
        });
        
        nrAuditoria[0].value = widget.currentRow.NRAUDITORIA;
        nrInspecAudi[0].value = widget.currentRow.NRINSPECAUDI;
        
        templateManager.container.getWidget('ANALINSPEC_ATIV').reload();
        
    };
    
    this.filtroRastreamentoInfoMat = function(widget){
        
        var nrLancNotaFiscal = templateManager.container.getWidget('InfoMatPrimaInsuFilha').dataSourceFilter.filter(function(data){
             return data.name == "P_NRLANCTONF";
        });
        
        nrLancNotaFiscal[0].value = widget.currentRow.NRLANCTONF;
        
        templateManager.container.getWidget('InfoMatPrimaInsuFilha').reload();
        
    };
    
    this.gerarLote = function(){
        
    };
    
    this.liberarLote = function(widget){
        
        ScreenService.closePopup();
        
        cdp01000_lote_de_producao_Service.retornaOperadorLogado().then(function(operadorLogado){
            
            widget.widgets[2].currentRow.CDOPERADOR =  operadorLogado[0].CDOPERADOR;
            
            widget.widgets[2].currentRow.NMOPERADOR =  operadorLogado[0].NMOPERADOR;
            
            widget.widgets[2].currentRow.DTATUAL = moment().format("DD-MM-YYYY hh:mm:ss");
        
            widget.widgets[2].reload();
            
            ScreenService.openPopup(widget.widgets[2]);
        
        });
        
    };
    
    this.liberarLoteConfirma = function(widget){
        
        cdp01000_lote_de_producao_Service.liberaLote(widget.parent.currentRow).then(
            function(Success) {
                ScreenService.closeSwipe().then(function () {
                    widget.activate();
                });
                widget.reload();
            },
            function(error){
                if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                    ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                } else {
                    ScreenService.showMessage(error.message);
                }
            }
        );
        
    };
    
    this.liberarLoteCancela = function(widget){
        ScreenService.closePopup();
        ScreenService.goBack();

    };
    
    this.cancelarLote = function(){
        
    };
    
}

Configuration(function(ContextRegister){
    ContextRegister.register('cdp01000_lote_de_producao_Controller', cdp01000_lote_de_producao_Controller);
});








