function cdp01300_ocorrencia_da_producaoController (ZHPromise, templateManager, restEngine, General, ScreenService, cdp01300_ocorrencia_da_producaoService){
    
    this.newGrupo = function(widget){
        widget.newRow();
        widget.widgets[0].enabled = false;
    };
    
    this.saveGrupo = function(widget){
        widget.widgets[0].enabled = true;
        General.saveCrud(widget);
    };
    
    this.editGrupo = function(widget){
        widget.widgets[0].enabled = false;
        General.edit(widget);
    };
    
    this.CancelGrupo = function(widget){
        widget.widgets[0].enabled = true;
    };
    
    this.deleteGrupo = function(widget){
        
       ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
    
            cdp01300_ocorrencia_da_producaoService.deletarGrupo(widget.currentRow).then(
                function(Success) {
                    ScreenService.closeSwipe().then(function () {
                        widget.activate();
                    });
                    widget.reload();
                },
                function(error){
                    if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                        ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                    } else {
                        ScreenService.showMessage(error.message);
                    }
                }
            );
        });
    };
    
    this.saveComplete = function(widget){
        widget.currentRow.CDGRPOCOR = widget.parent.currentRow.CDGRPOCOR;
        General.saveCrud(widget);
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('cdp01300_ocorrencia_da_producaoController', cdp01300_ocorrencia_da_producaoController);
});