function cdp01900_consulta_produto_por_materia_primaController (ZHPromise, templateManager, restEngine, General, ScreenService){
    
    this.deleteConsulta = function(widget){
        var deferred = ZHPromise.defer();
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
            widget.currentRow.__is_new = false;
        	widget.currentRow.changed = true;
            widget.currentRow.IDMARCADO = "N";
            widget.currentRow.IDRATCUSPROD =  "N";
            widget.currentRow.VRPERCUSMAT = "0";
            General.saveCrud(widget).then(function () {
					widget.activate();
					widget.reload();
					deferred.resolve();
			});
		});
		return deferred.promise;
    };
    
    this.mudaRateio = function() {
        
        var widget = templateManager.container.getActiveWidget();
        
        if((widget.currentRow.IDRATCUSPROD != "N") || (widget.currentRow.VRPERCUSMAT != 0)){
            widget.getField('IDMARCADO').value("S");
        }
        if((widget.currentRow.IDMARCADO == "S") && (widget.currentRow.IDRATCUSPROD == "N") && (widget.currentRow.VRPERCUSMAT == 0)){
            widget.getField('VRPERCUSMAT').value("100");
        } else if((widget.currentRow.IDMARCADO == "S") && (widget.currentRow.IDRATCUSPROD == "S")){
            widget.getField('VRPERCUSMAT').value("0");
        }
        
    };
    
    this.mudaCusto = function() {
        var widget = templateManager.container.getActiveWidget();
        
        if((widget.currentRow.IDRATCUSPROD != "N") || (widget.currentRow.VRPERCUSMAT != 0) ){
            widget.getField('IDMARCADO').value("S");
        }
        if(widget.currentRow.VRPERCUSMAT != "0"){
                widget.getField('IDRATCUSPROD').value("N");
        }
    };
    
    this.saveConsulta = function (widget){
        
        var VRPERCUSMAT = widget.currentRow.VRPERCUSMAT;
        
        if((widget.currentRow.IDMARCADO == "S") && (widget.currentRow.IDRATCUSPROD == "N") && (VRPERCUSMAT == 0)){
            ScreenService.showMessage('Percentual do cálculo do custo do produto acabado em relação ao custo da matéria prima deve ser informado.');
        } else if((VRPERCUSMAT >= 0) && (VRPERCUSMAT <= 100)){
            General.saveCrud(widget);
        }else {
            ScreenService.showMessage('Percentual do cálculo do custo do produto acabado em relação ao custo da matéria prima deve estar entre 0 e 100%');
            widget.getField('VRPERCUSMAT').value("0");
        }
            
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('cdp01900_consulta_produto_por_materia_primaController', cdp01900_consulta_produto_por_materia_primaController);
});
