function ger20000_via_de_acesso_administracaoController (templateManager, ScreenService, General){
    
    this.reload = function(){
		var widgetViaDeAcessoAdiministracao = templateManager.container.getWidget('widgetViaDeAcessoAdiministracao');
		widgetViaDeAcessoAdiministracao.reload();
	};
	
	this.create = function(widget) {
        widget.reload();
        widget.newRow();
        widget.currentRow.__is_new = true;
    };
    
    this.edit = function(widget){
        widget.backupRow = Util.clone(widget.currentRow);
        widget.edit();
    };
    
    this.cancel = function(widget){
        if(widget.currentRow.__is_new === true){
            widget.dataSource.data.pop();
            ScreenService.closeSwipe();
        } else {
            Util.extend(widget.currentRow, widget.backupRow);
            widget.view();
        }
        this.reload();
    };
    
    this.verificaCodigo = function(){
        var codigo = templateManager.container.getWidget('widgetViaDeAcessoAdiministracao').getField('CDVIACESDIET').value();
        if(isNaN(codigo)){
            ScreenService.showMessage("O campo 'Código' deve conter apenas números");
            templateManager.container.getWidget('widgetViaDeAcessoAdiministracao').getField('CDVIACESDIET').setValue('');
        }
    };
    
    this.salvar = function(widget){
        var codigo = templateManager.container.getWidget('widgetViaDeAcessoAdiministracao').getField('CDVIACESDIET').value();
        if(isNaN(codigo)){
            ScreenService.showMessage("O campo 'Código' deve conter apenas números");
            templateManager.container.getWidget('widgetViaDeAcessoAdiministracao').getField('CDVIACESDIET').setValue('');
        }
        else{
            General.saveCrud(widget);
        }
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('ger20000_via_de_acesso_administracaoController', ger20000_via_de_acesso_administracaoController);
});