var cdp01000_lote_de_producao_Repository = function (restEngine, localStorageEngine) {
    
    this.retornaUnidadeLogada = function() {
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
        ];
        return localStorageEngine.download("cdp#/crud/filial", filter);
    };

    this.retornaOperadorLogado = function() {
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        return localStorageEngine.download("cdp#/crud/operador", filter);
    };
    
    this.confirmaLiberaLote = function(row) {
        return restEngine.post('cdp_producao#/LiberaLote', {
            "requestType": "Row",
            "row": row
        });
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('cdp01000_lote_de_producao_Repository', cdp01000_lote_de_producao_Repository);
});