var ger02500_nutrienteService = function (restEngine, localStorageEngine) {

    this.retornaNutriente = function() {
        return restEngine.post('cdp#/crud/nutriente', {
            "requestType": "FilterData",
            "filter": [
                {"name": "NRORG", "operator": "=", "value": getLocalVar('NRORGTRAB')}
            ]
        });
    };

    this.salvaNutriente = function(row) {
        return restEngine.post('cdp#/nutriente/save', {
            "requestType": "Row",
            "row": row
        });
    };

    this.excluiNutriente = function(dataSet) { 
        return restEngine.post('cdp#/nutriente/remove', {
            "requestType": "DataSet",
            "dataset": dataSet
        });
    };

};
Configuration(function(ContextRegister) {
    ContextRegister.register('ger02500_nutrienteService', ger02500_nutrienteService);
});