function cdp06400_pontos_criticosController (ZHPromise, templateManager, restEngine, General, ScreenService, cdp06400_pontos_criticosService){
    
    this.newPonto = function(widget){
        widget.newRow();
        
        widget.widgets[0].enabled = false;
        widget.getField('CDARVINSPEC').readOnly= false;
        
        widget.currentRow.CDNVINSPECAO = '4';
        widget.currentRow.IDORIGINSPEC = 'PCC';
        	
		cdp06400_pontos_criticosService.incrementoCodigo(widget.currentRow).then(
		    function (success) {
		        widget.currentRow.CDINSPECAO = success.dataset.result[0].CDINSPECAO;
		    },
		    function (callback) {
			    if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
		    }
		);
        
    };
    
    this.savePonto = function(widget){
        widget.widgets[0].enabled = true;
        
        General.saveCrud(widget);
    };
    
    this.editPonto = function(widget){
        widget.widgets[0].enabled = false;
        widget.getField('CDARVINSPEC').readOnly= true;
       
        General.edit(widget);
    };
    
    this.cancelPonto = function(widget){
        widget.widgets[0].enabled = true;
    };
    
    this.saveComplete = function(widget){
        widget.currentRow.CDINSPECAO = widget.parent.currentRow.CDINSPECAO;
        General.saveCrud(widget);
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('cdp06400_pontos_criticosController', cdp06400_pontos_criticosController);
});
