var cdp04000_agenda_de_tarefas_Repository = function (restEngine, localStorageEngine) {

    this.retornaUnidadeLogada = function() {
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
        ];
        return localStorageEngine.download("cdp#/crud/filial", filter);
    };

    this.deleteAgenda = function(row) {
        return restEngine.post('cdp_producao#/DeletarAgenda', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.saveAgenda = function(row) {
        return restEngine.post('cdp_producao#/SaveAgenda', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.verificaInspec = function(row) {
        return restEngine.post('cdp_producao#/VerificaInspecao', {
            "requestType": "Row",
            "row": row
        });
    };
    
};

Configuration(function(ContextRegister){
    ContextRegister.register('cdp04000_agenda_de_tarefas_Repository', cdp04000_agenda_de_tarefas_Repository);
});